package com.iver.cit.gvsig;

import java.io.IOException;

import javax.swing.JOptionPane;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.project.documents.table.gui.Table;


/**
 * DOCUMENT ME!
 *
 * @author Vicente Caballero Navarro
 */
public class TableEditStopExtension extends Extension {
    /**
     * @see com.iver.andami.plugins.IExtension#initialize()
     */
    public void initialize() {
    }

    /**
     * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
     */
    public void execute(String actionCommand) {
    	IWindow v = PluginServices.getMDIManager().getActiveWindow();
    	Table table = (Table) v;
        if ("STOPEDITING".equals(actionCommand)) {
            stopEditing(table);
        }
		/* IEditableSource edTable = (IEditableSource) table.getModel().getAssociatedTable();
		edTable.getCommandRecord().removeCommandListener(table); */

    }

    /**
	 * DOCUMENT ME!
	 */
	public void stopEditing(Table table) {
		int resp = JOptionPane
				.showConfirmDialog(null, PluginServices.getText(this,
						"realmente_desea_guardar") +" : "+ table.getModel().getName(), "Guardar",
						JOptionPane.YES_NO_OPTION);
			if (resp == JOptionPane.NO_OPTION) { // CANCEL EDITING
				try {
					table.cancelEditing();
				} catch (IOException e) {
					e.printStackTrace();
				}
			} else { // GUARDAMOS LA TABLA
				table.stopEditing();
			}
	}


    /**
     * @see com.iver.andami.plugins.IExtension#isEnabled()
     */
    public boolean isEnabled() {
       return true;
    }

    /**
     * @see com.iver.andami.plugins.IExtension#isVisible()
     */
    public boolean isVisible() {
        IWindow v = PluginServices.getMDIManager().getActiveWindow();

        if (v == null) {
            return false;
        } else if (v instanceof Table && ((Table) v).isEditing() && ((Table)v).getModel().getAssociatedTable()==null) {
            return true;
        } else {
            return false;
        }
    }
}
