/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.panels;

import java.awt.BorderLayout;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.event.HyperlinkEvent;

import org.apache.log4j.Logger;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.andami.ui.mdiManager.WindowInfo;


/**
 * Vista donde mostrar el fichero del hiperlink.
 *
 * @author Vicente Caballero Navarro
 *
 */
public class LinkPanel extends JPanel implements IWindow {
	private static Logger logger = Logger.getLogger(LinkPanel.class.getName());
	private JPanel jPane = null;
	private JScrollPane jScrollPane = null;
	private JEditorPane jEditorPane1 = null;
	private JPanel jPanel = null; //  @jve:decl-index=0:visual-constraint="220,10"
	private JButton jButton = null;
	private String field;
	private String value;
	private String ext="";
	private int type=0;
	/**
	 * This is the default constructor
	 */
	public LinkPanel(String f,String v,String e,int t) {
		super();
		field=f;
		value=v;
		ext=e;
		type=t;
		initialize();
	}

	/**
	 * This method initializes this
	 */
	private void initialize() {
		this.setLayout(new BorderLayout());
		this.setSize(600, 450);
		this.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
		this.add(getJPanel(), java.awt.BorderLayout.SOUTH);
	}


	/**
	 * This method initializes jScrollPane
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setPreferredSize(new java.awt.Dimension(300, 400));
			jScrollPane.setViewportView(getJPane());
		}

		return jScrollPane;
	}

	/**
	 * This method initializes jEditorPane1
	 *
	 * @return javax.swing.JEditorPane
	 */
	private JPanel getJPane() {

		if (jPane == null) {
			jPane=new JPanel();

			//if (ext.equals(".htm") || ext.equals(".HTM") || ext.equals(".html") || ext.equals(".HTML") || ext.equals(".xml") || ext.equals(".XML") || ext.equals(".txt") || ext.equals(".TXT")){
			if (type==1){
				JEditorPane jEditorPane = new JEditorPane();
				jEditorPane.setAutoscrolls(true);
				jEditorPane.setEditable(false);
				jEditorPane.setContentType("text/html");
				//jEditorPane.setPreferredSize(new java.awt.Dimension(300, 200));
				String auxext="";
				if (!ext.equals("")){
					auxext="."+ext;
				}
				//URL url = LinkPanel.class.getResource(("/"+value+auxext));
				URL url=null;
				File file =new File(value+auxext);
				try {
					url = file.toURL();
				} catch (MalformedURLException e1) {
					e1.printStackTrace();
				}
			if (url != null) {
				try {
					jEditorPane.setPage(url);
					jEditorPane.addHyperlinkListener(new javax.swing.event.HyperlinkListener() {
							public void hyperlinkUpdate(
								javax.swing.event.HyperlinkEvent e) {
								if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
									JEditorPane pane = (JEditorPane) e.getSource();
									System.out.println("hyperlinkUpdate()");
									BrowserControl.displayURL(e.getURL()
															   .toString());

								}
							}
						});
				} catch (IOException e) {
					System.err.println("Attempted to read a bad URL: " +
						url);
				}
				jPane.add(jEditorPane);
			} else {
				System.err.println("Couldn't find file: " + value+auxext);
			}
		}else if (type==0){
			String auxext="";
			if (!ext.equals("")){
				auxext="."+ext;
			}
			//java.net.URL url = LinkPanel.class.getResource(("/" + value + auxext));
			URL url=null;
			File file =new File(value+auxext);
			try {
				url = file.toURL();
			} catch (MalformedURLException e1) {
				e1.printStackTrace();
			}
			ImageIcon image = null;

			if (url == null) {
				System.err.println("Couldn't find file: " + value+auxext);
			} else {
				image = new ImageIcon(url);
			}
			JLabel label = new JLabel(image);
			jPane.add(label);

			jPane.setVisible(true);

		}
		}

		return jPane;
	}

	/**
	 * This method initializes jPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			JLabel name = new JLabel();
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jPanel.setPreferredSize(new java.awt.Dimension(10, 50));
			jPanel.setSize(411, 50);
			name.setBounds(31, 20, 172, 17);
			String auxext="";
			if (!ext.equals("")){
				auxext="."+ext;
			}
			name.setText(field + " : " + value+auxext);
			jPanel.add(getJButton(), null);
			jPanel.add(name, null);
		}

		return jPanel;
	}

	/**
	 * This method initializes jButton
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
			jButton.setText(PluginServices.getText(this,"Cerrar"));
			jButton.setBounds(266, 12, 94, 25);
			jButton.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()

						if (PluginServices.getMainFrame() != null) {
							PluginServices.getMDIManager().closeWindow(LinkPanel.this);
						} else {
							((JDialog) (getParent().getParent().getParent()
											.getParent())).dispose();
						}
					}
				});
		}

		return jButton;
	}

	/* (non-Javadoc)
	 * @see com.iver.mdiApp.ui.MDIManager.View#getViewInfo()
	 */
	public WindowInfo getWindowInfo() {
		WindowInfo m_ViewInfo = new WindowInfo(WindowInfo.MODALDIALOG |
				WindowInfo.RESIZABLE);
		m_ViewInfo.setTitle(PluginServices.getText(this,"Hiperenlace"));

		return m_ViewInfo;
	}

	/* (non-Javadoc)
	 * @see com.iver.mdiApp.ui.MDIManager.View#viewActivated()
	 */
	public void viewActivated() {
		// TODO Auto-generated method stub
	}
} //  @jve:decl-index=0:visual-constraint="10,10"
