package es.prodevelop.cit.gvsig.arcims.gui.toc;

import java.awt.event.ActionEvent;

import javax.swing.JMenuItem;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.project.documents.view.gui.View;
import com.iver.cit.gvsig.project.documents.view.toc.TocMenuEntry;
import com.iver.cit.gvsig.project.documents.view.toc.gui.FPopupMenu;

import es.prodevelop.cit.gvsig.arcims.fmap.layers.FRasterLyrArcIMS;
import es.prodevelop.cit.gvsig.arcims.gui.dialogs.LayerScaleDialog;


/**
 * This class implements the scale limits status properties menu item that is
 * added to the ArcIMS layer's popup menu.

 * @author jldominguez
 */
public class ArcImsLayerScaleTocMenuEntry extends TocMenuEntry {
	
	private JMenuItem scaleMenuItem;
	FLayer lyr = null;
	private LayerScaleDialog scaleDialog;

	public void initialize(FPopupMenu m) {
		super.initialize(m);
		
		if (isTocItemBranch()) {
			lyr = getNodeLayer();
    		// ArcIMS layer
    		if ((lyr instanceof FRasterLyrArcIMS)) {
    			scaleMenuItem = new JMenuItem(PluginServices.getText(this, "layer_scale_status"));
    			getMenu().addSeparator();
    			getMenu().add( scaleMenuItem );
    			scaleMenuItem.setFont(FPopupMenu.theFont);
    			getMenu().setEnabled(true);
    			scaleMenuItem.addActionListener(this);   			
     		}
		}
		
	}

	/**
	 * Creates an LayerScaleDialog object and adds it to the MDIManager.
	 */
	public void actionPerformed(ActionEvent e) {
		
		if (scaleDialog != null) {
			PluginServices.getMDIManager().closeWindow(scaleDialog);
		}
		lyr = getNodeLayer();
		
		IWindow v = PluginServices.getMDIManager().getActiveWindow();
		View vista = null; if (v instanceof View) vista = (View) v;
		// vista.get
		scaleDialog = new LayerScaleDialog((FRasterLyrArcIMS) lyr, vista);
		PluginServices.getMDIManager().addWindow(scaleDialog);
	}

}

