/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */
package com.iver.cit.gvsig.fmap.layers;


/**
 * Este interfaz debe ser implementado por la clase que tenga la persistencia
 * de georreferenciacin.
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public interface IPersistence {
	
	/**
	 * Asigna la capa de puntos
	 * @param lyrPoints
	 */
	public void setLyrPoints(FLyrPoints lyrPoints);
	
	/**
	 * Carga la lista de puntos desde un fichero
	 * @param file	Nombre del fichero
	 * @return	Array con la lista de puntos
	 */
	public void loadPointList(String file);
	
	/**
	 * Crea el fichero Ascii con la lista de puntos y la salva a disco
	 * @param file
	 */
	public void saveCSVPointList(String file);
	
	/**
	 * Crea el fichero Ascii con la lista de puntos y la salva a disco
	 * @param file
	 */
	public void loadCSVPointList(String file);
	
	/**
	 * Crea el XML con la lista de puntos y la salva a disco
	 * @param file
	 */
	public void savePointList(String file);
}
