package org.gvsig.rasterTools.saveRaster.ui.main;

import javax.swing.JPanel;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.FlowLayout;

public class ButtonsPanel extends JPanel {

	private JPanel pFileName = null;
	private JPanel pButtons = null;
	private JLabel lFileTag = null;
	private JLabel lFileName = null;
	private JButton bSelect = null;
	private JButton bProperties = null;

	/**
	 * This is the default constructor
	 */
	public ButtonsPanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.insets = new java.awt.Insets(0,0,0,0);
		gridBagConstraints1.gridy = 1;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		this.setLayout(new GridBagLayout());
		this.setSize(347, 50);
		this.add(getJPanel(), gridBagConstraints);
		this.add(getJPanel1(), gridBagConstraints1);
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (pFileName == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setHgap(1);
			flowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
			flowLayout1.setVgap(2);
			lFileName = new JLabel();
			lFileName.setText("");
			lFileTag = new JLabel();
			lFileTag.setText("File:");
			pFileName = new JPanel();
			pFileName.setLayout(flowLayout1);
			pFileName.setPreferredSize(new java.awt.Dimension(347,20));
			pFileName.add(lFileTag, null);
			pFileName.add(lFileName, null);
		}
		return pFileName;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getJPanel1() {
		if (pButtons == null) {
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout.setHgap(2);
			flowLayout.setVgap(2);
			pButtons = new JPanel();
			pButtons.setLayout(flowLayout);
			pButtons.setPreferredSize(new java.awt.Dimension(347,22));
			pButtons.add(getBSelect(), null);
			pButtons.add(getBProperties(), null);
		}
		return pButtons;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	public JButton getBSelect() {
		if (bSelect == null) {
			bSelect = new JButton();
			bSelect.setPreferredSize(new java.awt.Dimension(110,20));
			bSelect.setText("Seleccionar");
		}
		return bSelect;
	}

	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	public JButton getBProperties() {
		if (bProperties == null) {
			bProperties = new JButton();
			bProperties.setPreferredSize(new java.awt.Dimension(160,20));
			bProperties.setText("Propiedades GTiff");
		}
		return bProperties;
	}

	/**
	 * Asigna el valor del texto de la etiqueta
	 * @param text cadena con el texto
	 */
	public void setLabelText(String text){
		lFileName.setText(text);
	}
	
	/**
	 * Obtiene el valor del texto de la etiqueta
	 * @return text cadena con el texto
	 */
	public JLabel getLabelText(){
		return lFileName;
	}
	
	/**
	 * Asigna el valor del texto de la etiqueta
	 * @param text cadena con el texto
	 */
	public void setTag(String tag){
		lFileTag.setText(tag);
	}
}
