/* gvSIG. Sistema de Informaci�n Geogr�fica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */

package org.cresques.ui.BrightnessContrast;

import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.cresques.filter.IStackManager;
import org.cresques.filter.RasterFilterStackManager;
import org.cresques.filter.enhancement.BrightnessContrastStackManager;
import org.cresques.io.GeoRasterFile;
import org.cresques.ui.filter.FilterRasterDialogPanel;
import org.cresques.ui.raster.IResize;


/**
 * Panel para los controles de brillo, contrase y realce.
 * @author Miguel Angel Querol Carratal <querol_mig@gva.es>
 *
 */
public class EnhancedBrightnessContrastPanel extends JPanel implements ActionListener, IResize{

	private int							wComp = 445, hComp = 239;
	private int							wPanels = (int)Math.round(wComp / 2) - 13, hPanels = hComp - 16;
	private int							wBright = wPanels - 22, hBright = hPanels - 73;
	private int							wEnhan = wBright, hEnhan = hPanels - 123;
	private int							wBCheck = wPanels - 28;
	private int							wSlider = wBright - 8, hSlider = 45;
	
	private String nom = "Realce";
	private JPanel pBrightCont = null;
	private JPanel pEnhanced = null;
	public LabelSliderText lstBrightness = null;
	public LabelSliderText lstContrast = null;
	private JPanel pBCCheck = null;
	private JPanel pBCSlider = null;
	private JPanel jPanel1 = null;
	private JCheckBox cBrightC = null;
	public JLabel lBrightC = null;
	private JPanel pEnCheck = null;
	private JPanel pEnSlider = null;
	private JCheckBox cEnhanced = null;
	private JPanel pDelInt = null;
	private JCheckBox jCheckBox = null;
	
	private BrightnessContrastStackManager bcManager = null;
	private JCheckBox jCheckBox1 = null;
	public JLabel lpreview = null;
	public RasterFilterStackManager rasterStackManager = null;
	public JLabel lLineal = null;
	public JLabel lRemove = null;
	public CheckSliderText cstEnhanced = null;
	private FilterRasterDialogPanel parent = null;
	
	public static final int h = 239;
	public static final int w = 445;
	
	/**
	 * This is the default constructor
	 */
	public EnhancedBrightnessContrastPanel() {
		super();
		initialize();
	}

	/**
	 * This is the default constructor
	 */
	public EnhancedBrightnessContrastPanel(FilterRasterDialogPanel parent) {
		super();
		this.parent = parent;
		initialize();
	}
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.insets = new java.awt.Insets(0,4,0,4);
		gridBagConstraints3.gridy = 0;
		gridBagConstraints3.gridx = 1;
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.insets = new java.awt.Insets(0,4,0,4);
		gridBagConstraints2.gridy = 0;
		gridBagConstraints2.gridx = 0;
		this.setLayout(new GridBagLayout());
		this.setSize(wComp, hComp);
		this.setPreferredSize(new java.awt.Dimension(wComp,hComp));
		this.add(getPBrightCont(), gridBagConstraints2);
		this.add(getPEnhanced(), gridBagConstraints3);
		
		this.getCBrightC().addActionListener(this);
		this.getCEnhanced().addActionListener(this);
		//this.addComponentListener(this);
		//this.getLabelSliderText().getJTextField().addActionListener(this);
		//this.getLabelSliderText1().getJTextField().addActionListener(this);
	}
	
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPBrightCont() {
		if (pBrightCont == null) {
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.insets = new java.awt.Insets(4,0,8,0);
			gridBagConstraints4.gridy = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.insets = new java.awt.Insets(0,8,4,8);
			gridBagConstraints.gridy = 0;
			pBrightCont = new JPanel();
			pBrightCont.setLayout(new GridBagLayout());
			pBrightCont.setPreferredSize(new java.awt.Dimension(wPanels,hPanels));
			pBrightCont.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Brillo y contraste", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			pBrightCont.add(getPBCCheck(), gridBagConstraints);
			pBrightCont.add(getPBCSlider(), gridBagConstraints4);
		}
		return pBrightCont;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPEnhanced() {
		if (pEnhanced == null) {
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 0;
			gridBagConstraints12.insets = new java.awt.Insets(4,4,59,4);
			gridBagConstraints12.gridy = 1;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.insets = new java.awt.Insets(0,8,4,8);
			gridBagConstraints11.gridy = 0;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 0;
			pEnhanced = new JPanel();
			pEnhanced.setLayout(new GridBagLayout());
			pEnhanced.setPreferredSize(new java.awt.Dimension(wPanels,hPanels));
			pEnhanced.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Realce", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			pEnhanced.add(getPEnCheck(), gridBagConstraints11);
			pEnhanced.add(getPEnSlider(), gridBagConstraints12);
		}
		return pEnhanced;
	}

	/**
	 * inicializa el conponente LabelSliderText
	 */
	public LabelSliderText getLabelSliderText(){
		if(lstBrightness == null){
			lstBrightness = new LabelSliderText();
			lstBrightness.setName("Brillo");
			lstBrightness.setSliderRange(-255,255);
			lstBrightness.setSliderValue(0);
		}
		return lstBrightness;
	}

	/**
	 * inicializa el conponente LabelSliderText
	 */
	public LabelSliderText getLabelSliderText1(){
		if (lstContrast == null){
			lstContrast = new LabelSliderText();
			lstContrast.setName("Contraste");
			lstContrast.setPreferredSize(new java.awt.Dimension(180,45));
			lstContrast.setSliderRange(-255,255);
			lstContrast.setSliderValue(0);
		}
		return lstContrast;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPBCCheck() {
		if (pBCCheck == null) {
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(java.awt.FlowLayout.LEFT);
			flowLayout.setVgap(0);
			flowLayout.setHgap(0);
			lBrightC = new JLabel();
			lBrightC.setText("Activar");
			lBrightC.setPreferredSize(new java.awt.Dimension(160,15));
			pBCCheck = new JPanel();
			pBCCheck.setLayout(flowLayout);
			pBCCheck.setPreferredSize(new java.awt.Dimension(wBCheck,25));
			pBCCheck.add(getCBrightC(), null);
			pBCCheck.add(lBrightC, null);
		}
		return pBCCheck;
	}

	/**
	 * This method initializes jPanel3	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPBCSlider() {
		if (pBCSlider == null) {
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 0;
			gridBagConstraints7.insets = new java.awt.Insets(0,0,2,0);
			gridBagConstraints7.gridy = 0;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 0;
			gridBagConstraints6.insets = new java.awt.Insets(10,0,8,0);
			gridBagConstraints6.gridy = 2;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.insets = new java.awt.Insets(0,0,0,0);
			gridBagConstraints5.gridy = 1;
			pBCSlider = new JPanel();
			pBCSlider.setLayout(new GridBagLayout());
			pBCSlider.setPreferredSize(new java.awt.Dimension(wBright,hBright));
			pBCSlider.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			pBCSlider.add(getLabelSliderText(), gridBagConstraints7);
			pBCSlider.add(getLabelSliderText1(), gridBagConstraints5);
			pBCSlider.add(getJPanel1(), gridBagConstraints6);
			this.setBCControlEnabled(false);
		}
		return pBCSlider;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
			flowLayout1.setVgap(0);
			flowLayout1.setHgap(0);
			lpreview = new JLabel();
			lpreview.setText("Previsualizacion");
			lpreview.setPreferredSize(new java.awt.Dimension(150,15));
			lpreview.setSize(new java.awt.Dimension(160,15));
			jPanel1 = new JPanel();
			jPanel1.setLayout(flowLayout1);
			jPanel1.setPreferredSize(new java.awt.Dimension(wSlider,25));
			jPanel1.add(getJCheckBox1(), null);
			jPanel1.add(lpreview, null);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getCBrightC() {
		if (cBrightC == null) {
			cBrightC = new JCheckBox();
		}
		return cBrightC;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPEnCheck() {
		if (pEnCheck == null) {
			FlowLayout flowLayout2 = new FlowLayout();
			flowLayout2.setHgap(0);
			flowLayout2.setAlignment(java.awt.FlowLayout.LEFT);
			flowLayout2.setVgap(0);
			lLineal = new JLabel();
			lLineal.setText("Lineal Directo");
			lLineal.setPreferredSize(new java.awt.Dimension(160,15));
			pEnCheck = new JPanel();
			pEnCheck.setLayout(flowLayout2);
			pEnCheck.setPreferredSize(new java.awt.Dimension(wBCheck,25));
			pEnCheck.add(getCEnhanced(), null);
			pEnCheck.add(lLineal, null);
		}
		return pEnCheck;
	}

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPEnSlider() {
		if (pEnSlider == null) {
			GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
			gridBagConstraints18.insets = new java.awt.Insets(2,0,0,0);
			gridBagConstraints18.gridy = 1;
			gridBagConstraints18.gridx = 0;
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.insets = new java.awt.Insets(0,0,2,0);
			gridBagConstraints15.gridy = 0;
			gridBagConstraints15.gridx = 0;
			pEnSlider = new JPanel();
			pEnSlider.setLayout(new GridBagLayout());
			pEnSlider.setPreferredSize(new java.awt.Dimension(wEnhan,hEnhan));
			pEnSlider.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			pEnSlider.add(getPDelInt(), gridBagConstraints15);
			pEnSlider.add(getCheckSliderText(), gridBagConstraints18);
			this.setEControlEnabled(false);
		}
		return pEnSlider;
	}

	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getCEnhanced() {
		if (cEnhanced == null) {
			cEnhanced = new JCheckBox();
		}
		return cEnhanced;
	}

	/**
	 * This method initializes jPanel3	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPDelInt() {
		if (pDelInt == null) {
			FlowLayout flowLayout3 = new FlowLayout();
			flowLayout3.setAlignment(java.awt.FlowLayout.LEFT);
			flowLayout3.setVgap(0);
			flowLayout3.setHgap(5);
			lRemove = new JLabel();
			lRemove.setText("Eliminar Extremos");
			lRemove.setPreferredSize(new java.awt.Dimension(150,15));
			pDelInt = new JPanel();
			pDelInt.setLayout(flowLayout3);
			pDelInt.setPreferredSize(new java.awt.Dimension(wSlider + 1,25));
			pDelInt.add(getJCheckBox(), null);
			pDelInt.add(lRemove, null);
		}
		return pDelInt;
	}

	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
		}
		return jCheckBox;
	}
	
	/**
	 * inicializa el conponente CheckSliderText
	 */
	public CheckSliderText getCheckSliderText(){
		String rcName = "Recorte de colas"; 
		if (cstEnhanced == null){
			cstEnhanced = new CheckSliderText();
			cstEnhanced.setName(rcName);
			cstEnhanced.setSliderValue(0);
			cstEnhanced.setSliderRange(0,50);
			cstEnhanced.setDecimal(true);
			cstEnhanced.setTextValue("0.0");
			
		}
		return cstEnhanced;
	}

	
	public void setComponentSize(int w,  int h){
		wComp = w; hComp = h;
		wPanels = (int)Math.round(wComp / 2) - 13; hPanels = hComp - 16;
		wBright = wPanels - 22; hBright = hPanels - 73;
		wEnhan = wBright; hEnhan = hPanels - 123;
		wBCheck = wPanels - 28;
		wSlider = wBright - 9; hSlider = 45;
		
		this.setSize(wComp, hComp);
		this.setPreferredSize(new java.awt.Dimension(wComp,hComp));
		pBrightCont.setPreferredSize(new java.awt.Dimension(wPanels,hPanels));
		pEnhanced.setPreferredSize(new java.awt.Dimension(wPanels,hPanels));
		pBCCheck.setPreferredSize(new java.awt.Dimension(wBCheck,25));
		pBCSlider.setPreferredSize(new java.awt.Dimension(wBright,hBright));
		this.lstBrightness.setComponentSize(wSlider, hSlider);
		this.lstContrast.setComponentSize(wSlider, hSlider);
		jPanel1.setPreferredSize(new java.awt.Dimension(wSlider,25));
		pEnSlider.setPreferredSize(new java.awt.Dimension(wEnhan,hEnhan));
		pEnCheck.setPreferredSize(new java.awt.Dimension(wBCheck,25));
		this.cstEnhanced.setComponentSize(wSlider, hSlider);
		pDelInt.setPreferredSize(new java.awt.Dimension(wSlider + 1,25));
		
		
	}
	
	
	/**
	 * Habilita o dehabilita el panel de brillo y contraste
	 * @param active
	 */
	public void setBCControlEnabled(boolean active){
		this.lstBrightness.setControlEnabled(active);
		this.lstContrast.setControlEnabled(active);
		this.getJCheckBox1().setEnabled(active);
		this.lpreview.setEnabled(active);
	}
	
	/**
	 * Habilita o dehabilita el panel de realce
	 * @param active
	 */
	public void setEControlEnabled(boolean active){
		this.jCheckBox.setEnabled(active);
		this.lRemove.setEnabled(active);
		this.cstEnhanced.setControlEnabled(active);		
	}
	
	/**
	 * Habilita o deshabilita el todo el panel
	 * @param active
	 */
	public void setControlEnabled(boolean active){
		this.setBCControlEnabled(active);
		this.setEControlEnabled(active);
		this.cBrightC.setEnabled(active);
		this.cEnhanced.setEnabled(active);
		this.lBrightC.setEnabled(active);
		this.lLineal.setEnabled(active);
		this.pBrightCont.setEnabled(active);
		this.pEnhanced.setEnabled(active);
	}
	
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == this.getCBrightC()){
			this.setBCControlEnabled(this.getCBrightC().isSelected());
		}
		if(e.getSource() == cEnhanced){
			this.setEControlEnabled(this.getCEnhanced().isSelected());
		}
	} 
	
	/**
	 * Asigna a este panel un stack manager
	 * @param p
	 */
	public void setBrightnessContrastStackManager (BrightnessContrastStackManager p){
		this.bcManager = p;
	}
	
	
	//-------------------------------------------------------------------------------

	public void setStackManager(RasterFilterStackManager stackManager) {
		// TODO Auto-generated method stub
		
	}
	
	public IStackManager getStackManager() {
		// TODO Auto-generated method stub
		return bcManager;
	}

	
	//----------------------------------------------------------------------------------
	
	
	public void removeFile(String file) {
		// TODO Auto-generated method stub
		
	}
	
	public void addFiles(GeoRasterFile[] files) {
		// TODO Auto-generated method stub
		
	}

	/**
	 * This method initializes jCheckBox1	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getJCheckBox1() {
		if (jCheckBox1 == null) {
			jCheckBox1 = new JCheckBox();
			jCheckBox1.setSelected(true);
		}
		return jCheckBox1;
	}
	
	 /**
     * Obtiene el nombre del panel
     * @return Cadena con el nombre del panel
     */
    public String getName(){
    	return this.nom;
    }   
	
}

