/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.tools.Events;

import com.iver.cit.gvsig.fmap.core.GeneralPathX;

import java.awt.event.MouseEvent;


/**
 * DOCUMENT ME!
 *
 * @author Vicente Caballero Navarro
 */
public class MeasureEvent {
	private GeneralPathX gp;
	private Double[] x;
	private Double[] y;
	private MouseEvent event;

	/**
	 * Crea un nuevo MeasureEvent.
	 *
	 * @param x Vector de coordenadas X.
	 * @param y Vector de coordenadas Y.
	 * @param e Evento que ocasion el MeasureEvent
	 */
	public MeasureEvent(Double[] x, Double[] y, MouseEvent e) {
		this.x = x;
		this.y = y;
		this.event = e;
		gp = new GeneralPathX(GeneralPathX.WIND_EVEN_ODD, x.length);
		gp.moveTo(x[0].doubleValue(), y[0].doubleValue());

		for (int index = 1; index < x.length; index++) {
			gp.lineTo(x[index].doubleValue(), y[index].doubleValue());
		}
	}

	/**
	 * Devuelve el GeneralPathX de la medicin.
	 *
	 * @return GeneralPathX.
	 */
	public GeneralPathX getGP() {
		return gp;
	}

	/**
	 * Inserta un GeneralPathX
	 *
	 * @param gp GeneralPathX.
	 */
	public void setGP(GeneralPathX gp) {
		this.gp = gp;
	}

	/**
	 * Devuelve el vector de X.
	 *
	 * @return Vector de X.
	 */
	public Double[] getXs() {
		return x;
	}

	/**
	 * Devuelve el vector de Y.
	 *
	 * @return Vector de Y.
	 */
	public Double[] getYs() {
		return y;
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public MouseEvent getEvent() {
		return event;
	}
}
