/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.utiles.listManager.sample;

import javax.swing.JFrame;

import com.iver.utiles.listManager.ListManagerDemoSkin;
import com.iver.utiles.listManager.ListManagerListener;
import com.iver.utiles.listManager.Propertiable;
public class Sample extends JFrame {

	private static int i = 0;
	
	private javax.swing.JPanel jContentPane = null;

	private ListManagerDemoSkin listManagerSkin = null;
	/**
	 * This method initializes listManager	
	 * 	
	 * @return com.iver.utiles.listManager.ListManager	
	 */    
	private ListManagerDemoSkin getListManager() {
		if (listManagerSkin == null) {
			listManagerSkin = new ListManagerDemoSkin();
			listManagerSkin.getListManager().setListener(new ListManagerListener() {
				/**
				 * @see com.iver.utiles.listManager.ListManagerListener#addObject()
				 */
				public Object[] addObjects() {
					Sample.i++;
					if (i < 3){
						return new String[]{"hola"};
					}
					return new PropString[]{new PropString("holap")};
				}

				/**
				 * @see com.iver.utiles.listManager.ListManagerListener#getProperties(java.lang.Object)
				 */
				public Object getProperties(Object selected) {
					return "propiedades";
				}
			});
		}
		return listManagerSkin;
	}
 	public static void main(String[] args) {
 		Sample s = new Sample();
 		s.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
 		s.show();
	}
	/**
	 * This is the default constructor
	 */
	public Sample() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300,200);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if(jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getListManager(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}
	
	public class PropString implements Propertiable{
		String properties;
		String texto;
		public PropString(String texto){
			this.texto = texto;
		}

		/**
		 * @see com.iver.utiles.listManager.Propertiable#setProperties(java.lang.Object)
		 */
		public void setProperties(Object o) {
			properties = (String) o;
		}
		
		/**
		 * @see java.lang.Object#toString()
		 */
		public String toString() {
			String ret = texto;
			if (properties != null){
				ret += "(" + properties + ")";
			}
			
			return ret;
		}
	}
}
