
//
// Vicente Caballero Navarro


package com.iver.cit.gvsig.gui.cad.tools.smc;

import com.iver.cit.gvsig.gui.cad.tools.ExploitCADTool;
import java.awt.event.InputEvent;
import com.iver.andami.PluginServices;

public final class ExploitCADToolContext
    extends statemap.FSMContext
{
//---------------------------------------------------------------
// Member methods.
//

    public ExploitCADToolContext(ExploitCADTool owner)
    {
        super();

        _owner = owner;
        setState(Exploit.Execute);
        Exploit.Execute.Entry(this);
    }

    public void addOption(String s)
    {
        _transition = "addOption";
        getState().addOption(this, s);
        _transition = "";
        return;
    }

    public void addPoint(double pointX, double pointY, InputEvent event)
    {
        _transition = "addPoint";
        getState().addPoint(this, pointX, pointY, event);
        _transition = "";
        return;
    }

    public void addValue(double d)
    {
        _transition = "addValue";
        getState().addValue(this, d);
        _transition = "";
        return;
    }

    public ExploitCADToolState getState()
        throws statemap.StateUndefinedException
    {
        if (_state == null)
        {
            throw(
                new statemap.StateUndefinedException());
        }

        return ((ExploitCADToolState) _state);
    }

    protected ExploitCADTool getOwner()
    {
        return (_owner);
    }

//---------------------------------------------------------------
// Member data.
//

    transient private ExploitCADTool _owner;

//---------------------------------------------------------------
// Inner classes.
//

    public static abstract class ExploitCADToolState
        extends statemap.State
    {
    //-----------------------------------------------------------
    // Member methods.
    //

        protected ExploitCADToolState(String name, int id)
        {
            super (name, id);
        }

        protected void Entry(ExploitCADToolContext context) {}
        protected void Exit(ExploitCADToolContext context) {}

        protected void addOption(ExploitCADToolContext context, String s)
        {
            Default(context);
        }

        protected void addPoint(ExploitCADToolContext context, double pointX, double pointY, InputEvent event)
        {
            Default(context);
        }

        protected void addValue(ExploitCADToolContext context, double d)
        {
            Default(context);
        }

        protected void Default(ExploitCADToolContext context)
        {
            throw (
                new statemap.TransitionUndefinedException(
                    "State: " +
                    context.getState().getName() +
                    ", Transition: " +
                    context.getTransition()));
        }

    //-----------------------------------------------------------
    // Member data.
    //
    }

    /* package */ static abstract class Exploit
    {
    //-----------------------------------------------------------
    // Member methods.
    //

    //-----------------------------------------------------------
    // Member data.
    //

        //-------------------------------------------------------
        // Statics.
        //
        /* package */ static Exploit_Default.Exploit_Execute Execute;
        private static Exploit_Default Default;

        static
        {
            Execute = new Exploit_Default.Exploit_Execute("Exploit.Execute", 0);
            Default = new Exploit_Default("Exploit.Default", -1);
        }

    }

    protected static class Exploit_Default
        extends ExploitCADToolState
    {
    //-----------------------------------------------------------
    // Member methods.
    //

        protected Exploit_Default(String name, int id)
        {
            super (name, id);
        }

        protected void addOption(ExploitCADToolContext context, String s)
        {
            ExploitCADTool ctxt = context.getOwner();

            if (s.equals(PluginServices.getText(this,"cancel")))
            {
                boolean loopbackFlag =
                    context.getState().getName().equals(
                        Exploit.Execute.getName());

                if (loopbackFlag == false)
                {
                    (context.getState()).Exit(context);
                }

                context.clearState();
                try
                {
                    ctxt.end();
                }
                finally
                {
                    context.setState(Exploit.Execute);

                    if (loopbackFlag == false)
                    {
                        (context.getState()).Entry(context);
                    }

                }
            }
            else
            {
                boolean loopbackFlag =
                    context.getState().getName().equals(
                        Exploit.Execute.getName());

                if (loopbackFlag == false)
                {
                    (context.getState()).Exit(context);
                }

                context.clearState();
                try
                {
                    ctxt.throwOptionException(PluginServices.getText(this,"incorrect_option"), s);
                }
                finally
                {
                    context.setState(Exploit.Execute);

                    if (loopbackFlag == false)
                    {
                        (context.getState()).Entry(context);
                    }

                }
            }

            return;
        }

        protected void addValue(ExploitCADToolContext context, double d)
        {
            ExploitCADTool ctxt = context.getOwner();

            boolean loopbackFlag =
                context.getState().getName().equals(
                    Exploit.Execute.getName());

            if (loopbackFlag == false)
            {
                (context.getState()).Exit(context);
            }

            context.clearState();
            try
            {
                ctxt.throwValueException(PluginServices.getText(this,"incorrect_value"), d);
            }
            finally
            {
                context.setState(Exploit.Execute);

                if (loopbackFlag == false)
                {
                    (context.getState()).Entry(context);
                }

            }
            return;
        }

        protected void addPoint(ExploitCADToolContext context, double pointX, double pointY, InputEvent event)
        {
            ExploitCADTool ctxt = context.getOwner();

            boolean loopbackFlag =
                context.getState().getName().equals(
                    Exploit.Execute.getName());

            if (loopbackFlag == false)
            {
                (context.getState()).Exit(context);
            }

            context.clearState();
            try
            {
                ctxt.throwPointException(PluginServices.getText(this,"incorrect_point"), pointX, pointY);
            }
            finally
            {
                context.setState(Exploit.Execute);

                if (loopbackFlag == false)
                {
                    (context.getState()).Entry(context);
                }

            }
            return;
        }

    //-----------------------------------------------------------
    // Inner classse.
    //


        private static final class Exploit_Execute
            extends Exploit_Default
        {
        //-------------------------------------------------------
        // Member methods.
        //

            private Exploit_Execute(String name, int id)
            {
                super (name, id);
            }

            protected void Entry(ExploitCADToolContext context)
            {
                ExploitCADTool ctxt = context.getOwner();

                ctxt.exploit();
                ctxt.end();
                return;
            }

        //-------------------------------------------------------
        // Member data.
        //
        }

    //-----------------------------------------------------------
    // Member data.
    //
    }
}
